---
 config.tests/mac/mac_version.test |    2 +-
 src/kernel/qcursor_mac.cpp        |    4 ++++
 src/kernel/qt_mac.h               |    2 +-
 src/tools/qglobal.h               |    5 ++++-
 4 files changed, 10 insertions(+), 3 deletions(-)

Index: qt3/config.tests/mac/mac_version.test
===================================================================
--- qt3.orig/config.tests/mac/mac_version.test	2008-03-25 22:34:33.000000000 -0600
+++ qt3/config.tests/mac/mac_version.test	2008-03-25 22:35:07.000000000 -0600
@@ -21,7 +21,7 @@ echo "#include <Carbon/Carbon.h>" >$TSTF
 echo "#include <stdio.h>" >>$TSTFILE
 echo "int main() {" >>$TSTFILE
 echo "  long gestalt_version;" >>$TSTFILE
-echo "  fprintf(stdout, \"%d\\n\", (Gestalt(gestaltSystemVersion, &gestalt_version) == noErr) ? gestalt_version : 0);" >>$TSTFILE
+/bin/echo "  fprintf(stdout, \"%d\\n\", (Gestalt(gestaltSystemVersion, &gestalt_version) == noErr) ? gestalt_version : 0);" >>$TSTFILE
 echo "  return 1;" >>$TSTFILE
 echo "}" >>$TSTFILE
 
Index: qt3/src/tools/qglobal.h
===================================================================
--- qt3.orig/src/tools/qglobal.h	2008-03-25 22:34:33.000000000 -0600
+++ qt3/src/tools/qglobal.h	2008-03-25 22:35:07.000000000 -0600
@@ -186,7 +186,10 @@
 #  if !defined(MAC_OS_X_VERSION_10_4)
 #       define MAC_OS_X_VERSION_10_4 MAC_OS_X_VERSION_10_3 + 1
 #  endif
-#  if (MAC_OS_X_VERSION_MAX_ALLOWED > MAC_OS_X_VERSION_10_4)
+#  if !defined(MAC_OS_X_VERSION_10_5)
+#       define MAC_OS_X_VERSION_10_5 MAC_OS_X_VERSION_10_4 + 1
+#  endif
+#  if (MAC_OS_X_VERSION_MAX_ALLOWED > MAC_OS_X_VERSION_10_5)
 #    error "This version of Mac OS X is unsupported"
 #  endif
 #endif
Index: qt3/src/kernel/qt_mac.h
===================================================================
--- qt3.orig/src/kernel/qt_mac.h	2008-01-15 12:08:57.000000000 -0700
+++ qt3/src/kernel/qt_mac.h	2008-03-25 22:35:07.000000000 -0600
@@ -60,7 +60,7 @@
 # define QMAC_DEFAULT_STYLE "QMacStyle" //DefaultStyle
 #endif
 
-#if !defined(Q_WS_MACX) || QT_MACOSX_VERSION < 0x1020 || QT_MACOSX_VERSION >= 0x1030
+#if !defined(Q_WS_MACX) || QT_MACOSX_VERSION < 0x1020 || (QT_MACOSX_VERSION >= 0x1030 && QT_MACOSX_VERSION <= 0x1040)
 # define QMAC_NO_FAKECURSOR
 #endif
 
Index: qt3/src/kernel/qcursor_mac.cpp
===================================================================
--- qt3.orig/src/kernel/qcursor_mac.cpp	2008-03-25 22:34:33.000000000 -0600
+++ qt3/src/kernel/qcursor_mac.cpp	2008-03-25 22:35:07.000000000 -0600
@@ -183,7 +183,9 @@ struct QCursorData : public QShared
 #ifdef QMAC_USE_BIG_CURSOR_API
 	char *big_cursor_name;
 #endif
+#ifdef QMAC_NO_FAKECURSOR
 	CursorImageRec *ci;
+#endif
 	struct {
 	    QMacAnimateCursor *anim;
 	    ThemeCursor curs;
@@ -263,8 +265,10 @@ QCursorData::~QCursorData()
     if(type == TYPE_CursPtr) {
 	if(curs.cp.hcurs && curs.cp.my_cursor)
 	    free(curs.cp.hcurs);
+#ifdef QMAC_NO_FAKECURSOR
     } else if(type == TYPE_CursorImage) {
 	free(curs.ci);
+#endif
 #ifdef QMAC_USE_BIG_CURSOR_API
     } else if(type == TYPE_BigCursor) {
 	QDUnregisterNamedPixMapCursur(curs.big_cursor_name);
